local mp = require "mp"


DELAY=0 -- delay to wait after new refresh rate has been detected (in s)
DELTA=0.5 -- delta of initial and new refresh rate, that will be handled as same refresh rates (in Hz)


fpsInit = nil
function on_start(event)
	fpsInit = round2digit(mp.get_property_number("display-fps"))
	print("fpsInit", fpsInit)
	local fpsVideo = round2digit(mp.get_property_number("container-fps"))
	print("fpsVideo", fpsVideo)

	if math.abs(fpsInit - fpsVideo) > DELTA then
		mp.set_property("pause", "yes")
		mp.observe_property("display-fps", "number", on_display_fps)
		print("pause")
	end
end

function on_display_fps(name, value)
	if value ~= nil then
		local fpsCurrent = round2digit(value)
		print("fpsCurrent", fpsCurrent)
		if fpsCurrent ~= fpsInit then
			mp.add_timeout(DELAY,
				function()
					print("unpause")
					mp.set_property("pause", "no")
				end
			)			
			mp.unobserve_property(on_display_fps)
		end
	end
end

function round2digit(value)
	if value ~= nil then
		return math.floor(value * 100 + 0.5) / 100
	end
	return 0
end

mp.register_event("file-loaded", on_start)
